Index: gcc/testsuite/gcc.target/powerpc/bmi-andn-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-andn-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-andn-1.c	(working copy)
@@ -1,5 +1,5 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64" } */
+/* { dg-options "-O3" } */
 /* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
Index: gcc/testsuite/gcc.target/powerpc/bmi-andn-2.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-andn-2.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-andn-2.c	(working copy)
@@ -1,5 +1,5 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64" } */
+/* { dg-options "-O3" } */
 /* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
Index: gcc/testsuite/gcc.target/powerpc/bmi-bextr-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-bextr-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-bextr-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O2 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O2 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-bextr-2.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-bextr-2.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-bextr-2.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-bextr-4.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-bextr-4.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-bextr-4.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-bextr-5.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-bextr-5.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-bextr-5.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-blsi-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-blsi-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-blsi-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-blsi-2.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-blsi-2.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-blsi-2.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-blsmsk-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-blsmsk-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-blsmsk-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-blsmsk-2.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-blsmsk-2.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-blsmsk-2.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-blsr-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-blsr-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-blsr-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-blsr-2.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-blsr-2.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-blsr-2.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-tzcnt-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-tzcnt-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-tzcnt-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi-tzcnt-2.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi-tzcnt-2.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi-tzcnt-2.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
+/* { dg-options "-O3 -fno-inline" } */
 /* { dg-require-effective-target lp64 } */
-/* { dg-options "-O3 -m64 -fno-inline" } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi2-bzhi32-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-bzhi32-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-bzhi32-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
-/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi2-bzhi64-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-bzhi64-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-bzhi64-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
-/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi2-bzhi64-1a.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-bzhi64-1a.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-bzhi64-1a.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do compile } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
-/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi2-mulx32-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-mulx32-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-mulx32-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
-/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include "bmi2-check.h"
Index: gcc/testsuite/gcc.target/powerpc/bmi2-mulx32-2.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-mulx32-2.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-mulx32-2.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
-/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi2-mulx64-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-mulx64-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-mulx64-1.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
-/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include "bmi2-check.h"
Index: gcc/testsuite/gcc.target/powerpc/bmi2-mulx64-2.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-mulx64-2.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-mulx64-2.c	(working copy)
@@ -1,6 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
-/* { dg-require-effective-target powerpc_vsx_ok } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 
 #define NO_WARN_X86_INTRINSICS 1
 #include <x86intrin.h>
Index: gcc/testsuite/gcc.target/powerpc/bmi2-pdep32-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-pdep32-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-pdep32-1.c	(working copy)
@@ -1,5 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 /* { dg-require-effective-target powerpc_vsx_ok } */
 
 #define NO_WARN_X86_INTRINSICS 1
Index: gcc/testsuite/gcc.target/powerpc/bmi2-pdep64-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-pdep64-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-pdep64-1.c	(working copy)
@@ -1,5 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 /* { dg-require-effective-target powerpc_vsx_ok } */
 
 #define NO_WARN_X86_INTRINSICS 1
Index: gcc/testsuite/gcc.target/powerpc/bmi2-pext32-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-pext32-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-pext32-1.c	(working copy)
@@ -1,5 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 /* { dg-require-effective-target powerpc_vsx_ok } */
 
 #define NO_WARN_X86_INTRINSICS 1
Index: gcc/testsuite/gcc.target/powerpc/bmi2-pext64-1.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-pext64-1.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-pext64-1.c	(working copy)
@@ -1,5 +1,6 @@
 /* { dg-do run } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 /* { dg-require-effective-target powerpc_vsx_ok } */
 
 #define NO_WARN_X86_INTRINSICS 1
Index: gcc/testsuite/gcc.target/powerpc/bmi2-pext64-1a.c
===================================================================
--- gcc/testsuite/gcc.target/powerpc/bmi2-pext64-1a.c	(revision 248166)
+++ gcc/testsuite/gcc.target/powerpc/bmi2-pext64-1a.c	(working copy)
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
-/* { dg-options "-O3 -m64 -mcpu=power7" } */
+/* { dg-options "-O3" } */
+/* { dg-require-effective-target lp64 } */
 /* { dg-require-effective-target powerpc_vsx_ok } */
 
 #define NO_WARN_X86_INTRINSICS 1